=== debian/changelog ===
genomicsdb (1.5.3-3) unstable; urgency=medium

  * Adding Breaks+Replaces: libgenomicsdb0 for libgenomicsdb1
    (Closes: #1078472)

 -- Pierre Gruet <pgt@debian.org>  Sun, 11 Aug 2024 22:56:12 +0200

genomicsdb (1.5.3-2) unstable; urgency=medium

  * Source-only upload to unstable

 -- Pierre Gruet <pgt@debian.org>  Sat, 10 Aug 2024 07:42:47 +0200

genomicsdb (1.5.3-1) experimental; urgency=medium

  * New upstream version 1.5.3
  * Refreshing patches
  * Raising Standards version to 4.7.0 (no change)
  * Bumping SOVERSION, now set in the upstream files, to 1
  * Rewriting d/copyright
  * Installing pkgconfig file in the -dev package
  * Clarifying an ambiguous assertion in the tests
  * Adding missing #IFDEF DEBUG in a source file
  * Writing a substitute for missing GetLength() method of rapidjson
  * Build-depending on mpi-default-dev instead of libopenmpi-dev
  * Patching out a test assertion because of outdated protobuf in Debian

 -- Pierre Gruet <pgt@debian.org>  Thu, 08 Aug 2024 16:49:10 +0200

genomicsdb (1.5.0-2) unstable; urgency=medium

  * Allowing the package to build against catch2 3.x (Closes: #1054675)

 -- Pierre Gruet <pgt@debian.org>  Fri, 03 Nov 2023 17:16:04 +0100
